xfs
[Top] [All Lists]

[PATCH 1/4] xfstests generic 308: check ctime updates for setfacl

To: xfs@xxxxxxxxxxx
Subject: [PATCH 1/4] xfstests generic 308: check ctime updates for setfacl
From: Eryu Guan <eguan@xxxxxxxxxx>
Date: Mon, 1 Apr 2013 18:57:41 +0800
Cc: Eryu Guan <eguan@xxxxxxxxxx>
Delivered-to: xfs@xxxxxxxxxxx
In-reply-to: <1364813864-10820-1-git-send-email-eguan@xxxxxxxxxx>
References: <1364813864-10820-1-git-send-email-eguan@xxxxxxxxxx>
Check if ctime is updated and written to disk after setfacl

Regression test for the following extN commits
c6ac12a ext4: update ctime when changing the file's permission by setfacl
30e2bab ext3: update ctime when changing the file's permission by setfacl
523825b ext2: update ctime when changing the file's permission by setfacl

Signed-off-by: Eryu Guan <eguan@xxxxxxxxxx>
---
 tests/generic/308     | 79 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/308.out |  2 ++
 tests/generic/group   |  1 +
 3 files changed, 82 insertions(+)
 create mode 100644 tests/generic/308
 create mode 100644 tests/generic/308.out

diff --git a/tests/generic/308 b/tests/generic/308
new file mode 100644
index 0000000..797a907
--- /dev/null
+++ b/tests/generic/308
@@ -0,0 +1,79 @@
+#! /bin/bash
+# FS QA Test No. 308
+#
+# Check if ctime is updated and written to disk after setfacl
+#
+# Regression test for the following extN commits
+# c6ac12a ext4: update ctime when changing the file's permission by setfacl
+# 30e2bab ext3: update ctime when changing the file's permission by setfacl
+# 523825b ext2: update ctime when changing the file's permission by setfacl
+#
+# Based on test 277
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Red Hat, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+status=1       # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+       cd /
+       rm -f $testfile
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+testfile=$SCRATCH_MNT/testfile.$seq
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+
+echo "Silence is golden"
+
+_scratch_mkfs >/dev/null 2>&1
+_scratch_mount >/dev/null 2>&1
+
+touch $testfile
+_scratch_remount
+ctime1=`stat -c %Z $testfile`
+
+sleep 1
+setfacl -m 'u::x,g::x,o::x' $testfile
+ctime2=`stat -c %Z $testfile`
+
+_scratch_remount
+ctime3=`stat -c %Z $testfile`
+
+if [ "$ctime1" == "$ctime2" ]; then
+       echo "error: ctime not updated after setfacl"
+elif [ "$ctime1" == "$ctime3" ]; then
+       echo "error: on disk ctime not updated"
+else
+       status=0
+fi
+
+exit
diff --git a/tests/generic/308.out b/tests/generic/308.out
new file mode 100644
index 0000000..a731eaa
--- /dev/null
+++ b/tests/generic/308.out
@@ -0,0 +1,2 @@
+QA output created by 308
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index 450e942..6c74b63 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -109,3 +109,4 @@
 299 auto aio enospc rw stress
 300 auto aio enospc preallocrw stress
 306 auto quick rw
+308 auto quick
-- 
1.8.1.4

<Prev in Thread] Current Thread [Next in Thread>